#!/usr/bin/perl
use strict;

my $count = 0;
my $base = 64;
my $longsize = 4;
my $columnsize = 2;
my $dbtype = 1;
my $filename_in = "IP-COUNTRY.CSV";
my $filename_out = "IP-COUNTRY.BIN";
my %db;
my %country;

open IN, "<$filename_in" or die;
while (<IN>) {
	$_ =~ s/\n//g;
	$_ =~ s/^\"//;	
	$_ =~ s/\"$//;
	my @array = split (/\",\"/, $_);
	$db{$array[0]}{"country"} = $array[2];
	$country{$array[2]}{"LONG"} = $array[3];
	$count++;
}
close IN;

$count++;
my $addr = $base + $count * $longsize * $columnsize;

foreach my $co (sort keys(%country)) {
	$country{$co}{"ADDR"} = $addr;
	$addr = $addr + 1 + 2 + 1 + length($country{$co}{"LONG"});
}

my ($Second, $Minute, $Hour, $Day, $Month, $Year, $WeekDay, $DayOfYear, $IsDST) = localtime(time) ; 

open OUT, ">$filename_out" or die;
binmode(OUT);

# DB1
print OUT pack("C", $dbtype);

# 2 COLUMNS
print OUT pack("C", $columnsize);

print OUT pack("C", $Year - 100);
print OUT pack("C", $Month + 1);
print OUT pack("C", $Day);

print OUT pack("V", $count);

print OUT pack("V", 64+1);

print OUT pack("V", 0);

foreach my $i (17..63) {
	print OUT pack("C", 0);
}

foreach my $ip (sort {$a <=> $b} keys(%db)) {
	print OUT pack("V", $ip);
	print OUT pack("V", $country{$db{$ip}{"country"}}{"ADDR"});
}

print OUT pack("V", 4294967295);
print OUT pack("V", $country{"-"}{"ADDR"});

foreach my $co (sort keys(%country)) {
	print OUT pack("C", length($co));
	print OUT $co;
	if ($co eq "-") {
		print OUT " ";
	}
	print OUT pack("C", length($country{$co}{"LONG"}));
	print OUT $country{$co}{"LONG"};
}

close OUT;

print STDOUT "$filename_in to $filename_out conversion done.\n";
